// Generated by P1V_Toolbox Version p1v_toolbox_v1_45 4/03/2022
// Created : 4/03/2022 10:56:50 AM
// Source path : D:\p1_fpga
// Reference path : c:\p1_fpga
// Project name : fredx.p1v
// Destination : D:\p1_fpga\fredx
// Board : Terasic DE10_Lite
// Family : Max 10
// Device : 10M50DAF484C7G
// Program mode : Internal configuration + Single Uncompressed Image 512k
// Configuration device : n/a
// Loader device : 
// Top entity name : top
// Cogs = 8
// Counters = 2
// Video is enabled
// Hub ram 32k
// Character rom is enabled
// High ROM size = 16k ($C000 to $FFFF)
// High_ROM filename : D:\p1_fpga\unscrambled.hex
// Propeller Version number = 1
// PLL multipler = 16
// PLL divider = 5
// Clock frequency = 160 MHz (80 MHz)
// Invert Cog LEDS is disabled
// Toy filename : D:\p1_fpga\toys\de10.toys
// Pin filename : 
// Asymmetrical cog mode is disabled
// Hub slots = 8 (1:16) Hub Boost is disabled
// Propellers = 1
// PortB [BiDir] is enabled
// PortC [IN] is disabled
// PortD [IN] is disabled
// PortE [IN] is disabled
// PortF [IN] is disabled
// PortG [IN] is disabled

// cog_ctr

/*
-------------------------------------------------------------------------------
Copyright 2014 Parallax Inc.

This file is part of the hardware description for the Propeller 1 Design.

The Propeller 1 Design is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your option)
any later version.

The Propeller 1 Design is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
the Propeller 1 Design.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------
*/

module              cog_ctr
(
input               clk_cog,
input               clk_pll,

input               ena,

input               setctr,
input               setfrq,
input               setphs,

input       [31:0]  data,

input       [31:0]  pin_in,
input       [31:0]  pin_inb,  // <=- PortB

output reg  [32:0]  phs,

output      [31:0]  pin_out,
output      [31:0]  pin_outb,  // <=- PortB

output              pll
);


// control

reg [31:0] ctr;
reg [31:0] frq;

always @(posedge clk_cog or negedge ena)
if (!ena)
    ctr <= 32'b0;
else if (setctr)
    ctr <= data;

always @(posedge clk_cog)
if (setfrq)
    frq <= data;

always @(posedge clk_cog)
if (setphs || trig)
    phs <= setphs ? {1'b0, data} : {1'b0, phs[31:0]} + {1'b0, frq};


// input pins

reg [1:0] dly;

always @(posedge clk_cog)
if (|ctr[30:29])
      dly <= {ctr[30] ? (ctr[14] ? pin_inb[ctr[13:9]] : pin_in[ctr[13:9]]) : dly[0], (ctr[5] ? pin_inb[ctr[4:0]] : pin_in[ctr[4:0]])};  // <=- PortB


// trigger, outputs

                    //  trigger         outb        outa
wire [15:0][2:0] tp = { dly == 2'b10,   !dly[0],    1'b0,       // neg edge w/feedback
                        dly == 2'b10,   1'b0,       1'b0,       // neg edge
                        !dly[0],        !dly[0],    1'b0,       // neg w/feedback
                        !dly[0],        1'b0,       1'b0,       // neg
                        dly == 2'b01,   !dly[0],    1'b0,       // pos edge w/feedback
                        dly == 2'b01,   1'b0,       1'b0,       // pos edge
                        dly[0],         !dly[0],    1'b0,       // pos w/feedback
                        dly[0],         1'b0,       1'b0,       // pos
                        1'b1,           !phs[32],   phs[32],    // duty differential
                        1'b1,           1'b0,       phs[32],    // duty single
                        1'b1,           !phs[31],   phs[31],    // nco differential
                        1'b1,           1'b0,       phs[31],    // nco single
                        1'b1,           !pll,       pll,        // pll differential
                        1'b1,           1'b0,       pll,        // pll single
                        1'b1,           1'b0,       1'b0,       // pll internal
                        1'b0,           1'b0,       1'b0 };     // off

wire [3:0] pick     = ctr[29:26];
wire [2:0] tba      = tp[pick];

wire trig           = ctr[30] ? pick[dly]   : tba[2];       // trigger
wire outb           = ctr[30] ? 1'b0        : tba[1];       // outb
wire outa           = ctr[30] ? 1'b0        : tba[0];       // outa


// output pins

wire [31:0] mask_a = outa << ctr[4:0];  // <=- PortB
wire [31:0] mask_b = outb << ctr[13:9];  // <=- PortB

assign pin_out = !ctr[14] && !ctr[5] ? mask_a | mask_b   // <=- PortB
                  :!ctr[14] && ctr[5] ? mask_b  // <=- PortB
                  :ctr[14] && !ctr[5] ? mask_a  // <=- PortB
                  :32'b0;  // <=- PortB

assign pin_outb = ctr[14] && ctr[5] ? mask_a | mask_b   // <=- PortB
                  :ctr[14] && !ctr[5] ? mask_b  // <=- PortB
                  :!ctr[14] && ctr[5] ? mask_a  // <=- PortB
                  :32'b0;  // <=- PortB

// pll simulator

reg [35:0] pll_fake;

always @(posedge clk_pll)
if (~|ctr[30:28] && |ctr[27:26])
    pll_fake <= pll_fake + {4'b0, frq};

wire [7:0] pll_taps = pll_fake[35:28];

assign pll          = pll_taps[~ctr[25:23]];

endmodule

